Subject: Re: [syzbot] [kernel?] linux-next test error: WARNING in class_for_each_device

From: "Danilo Krummrich" <[email-masked]>
Date: Tue, 26 May 2026 14:03:48 +0200

On Tue May 26, 2026 at 1:59 PM CEST, Tetsuo Handa wrote:
> On 2026/05/26 16:19, Tetsuo Handa wrote:
>> On 2026/05/26 15:08, Tetsuo Handa wrote:
>>> On 2026/05/26 14:55, syzbot wrote:
>>>> Hello,
>>>>
>>>> syzbot found the following issue on:
>>>>
>>>> HEAD commit:    d387b06f7c15 Add linux-next specific files for 20260525
>>>> git tree:       linux-next
>>>> console output: https://syzkaller.appspot.com/x/log.txt?x=15eb7796580000
>>>> kernel config:  https://syzkaller.appspot.com/x/.config?x=8dd72cf810e753a6
>>>> dashboard link: https://syzkaller.appspot.com/bug?extid=50b5f81fff158669504a
>>>> compiler:       Debian clang version 21.1.8 (++20251221033036+2078da43e25a-1~exp1~20251221153213.50), Debian LLD 21.1.8
>>>>
>>>> Downloadable assets:
>>>> disk image: https://storage.googleapis.com/syzbot-assets/39490dfbc250/disk-d387b06f.raw.xz
>>>> vmlinux: https://storage.googleapis.com/syzbot-assets/0789ac7ac5fc/vmlinux-d387b06f.xz
>>>> kernel image: https://storage.googleapis.com/syzbot-assets/4464df9f5ccf/bzImage-d387b06f.xz
>>>>
>>>> IMPORTANT: if you fix the issue, please add the following tag to the commit:
>>>> Reported-by: [email-masked]
>>>>
>>>> ------------[ cut here ]------------
>>>> class_for_each_device called for class 'devlink' before it was registered
>>> https://git.kernel.org/pub/scm/linux/kernel/git/next/linux-next.git/commit/drivers/base?id=1137838865bfc9a7cd5869c1dc5c22aa45ec12c8
>>>
>>> Why "driver_deferred_probe_timeout * HZ" => "driver_deferred_probe_timeout" ?
>>>
>> 
>> Here is an analysis from Google AI mode regarding this problem: https://share.google/aimode/UO1WnoKPDSbyjY5Qj
>> 
>> Greg, can you immediately drop commit 1137838865bf ("driver core: Use mod_delayed_work to prevent
>> lost deferred probe work") so that syzbot can resume testing linux-next tree as soon as possible?
>> 
>
> Below diff was generated via conversation with AI Mode in Google Search, and
> I agree that this diff should fix the problem. I'm waiting for Greg's response
> on how to proceed. Mark, can you carry below diff as a hotfix for linux-next tree?

As mentioned in the previous reply, I already posted patches for this in [1];
will pick them up today.

[1] https://lore.kernel.org/driver-core/[email-masked]/t/#u